import java.io.File;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import javax.persistence.TypedQuery;

public class EntityBulkUpdateTest {

	public static void main(String[] args) throws InterruptedException {

		System.setProperty("objectdb.conf",
				"C:/Entwicklung/Java/objectdb-2.5.0_04/objectdb.conf");

		new File("C:/bulk-update-test.odb").deleteOnExit(); //$NON-NLS-1$
		EntityManagerFactory factory = Persistence
				.createEntityManagerFactory("C:/bulk-update-test.odb;drop"); //$NON-NLS-1$
		EntityManager entityManager = factory.createEntityManager();
		entityManager.getTransaction().begin();
		EntityBulkUpdate test1_1 = new EntityBulkUpdate(1, "Test1"); //$NON-NLS-1$
		EntityBulkUpdate test1_2 = new EntityBulkUpdate(1, "Test2"); //$NON-NLS-1$
		EntityBulkUpdate test1_3 = new EntityBulkUpdate(1, "Test3"); //$NON-NLS-1$
		EntityBulkUpdate test2 = new EntityBulkUpdate(2, "Test"); //$NON-NLS-1$
		EntityBulkUpdateContainer container = new EntityBulkUpdateContainer();
		container.entities.add(test1_1);
		container.entities.add(test1_2);
		container.entities.add(test1_3);
		container.entities.add(test2);
		entityManager.persist(container);
		entityManager.getTransaction().commit();

		for (EntityBulkUpdate entity : container.entities)
			System.out.println(entity.getKey() + " : " + entity.getName());

		entityManager.getTransaction().begin();
		Query q = entityManager
				.createQuery("UPDATE EntityBulkUpdate p SET p.name =  p.name + :name WHERE p.key = :key");
		q.setParameter("key", 1);
		q.setParameter("name", "updt");
		System.out.println("affectedObjects=" + q.executeUpdate());

		entityManager.getTransaction().commit();
		entityManager.flush();
		// entityManager.clear();

		// SELECT-Query for fetching EntityContainer
		TypedQuery<EntityBulkUpdateContainer> typedQuery = entityManager
				.createQuery("SELECT FROM EntityBulkUpdateContainer", //$NON-NLS-1$
						EntityBulkUpdateContainer.class);

		for (EntityBulkUpdate entity : typedQuery.getSingleResult().entities)
			System.out.println(entity.getKey() + " : " + entity.getName()); //$NON-NLS-1$

		// SELECT-Query for direct fetching Entities
		TypedQuery<EntityBulkUpdate> typedQuery2 = entityManager.createQuery(
				"SELECT FROM EntityBulkUpdate", //$NON-NLS-1$
				EntityBulkUpdate.class);

		for (EntityBulkUpdate entity : typedQuery2.getResultList())
			System.out.println(entity.getKey() + " : " + entity.getName()); //$NON-NLS-1$

		entityManager.close();
		factory.close();
	}

}
